unsigned int getStringLength(char *string);
void print(char *string);
void restartMenu(void);

void entry(void)
{
    // print our string
    print("Hello, world!\n");

    // restart the menu
    restartMenu();
}

void print(char *string)
{
    unsigned int length;
    length = getStringLength(string);

    asm volatile
    (
		"mov r0, #1\n"      // stdout
		"mov r1, %0\n"      // the string
        "mov r2, %1\n"      // the length
        "swi #0x900004\n"   // write
        :  // no output
        : "r"(string), "r"(length)  // %0 and %1 input args
        : "r0", "r1", "r2"   // registers we clobber
    );
}

unsigned int getStringLength(char *string)
{
	unsigned int i = 0;
	while(string[i] != 0)
	{
		i++;
	}
	return i;
}

void restartMenu(void)
{
    char *pszMenuDir = "/usr/gp2x";
    char *pszMenuCmd = "/usr/gp2x/gp2xmenu";

    asm volatile
    (
		"mov r0, %0\n"      // directory
        "swi #0x90000C\n"   // chdir

		"mov r0, %1\n"      // program to execute
        "mov r1, #0\n"      // arg 2 = NULL
        "mov r2, #0\n"      // arg 3 = NULL
        "swi #0x90000B\n"   // execve
        :   // no output
        : "r"(pszMenuDir), "r"(pszMenuCmd)  // %0 and %1 inputs
        : "r0", "r1", "r2"     // registers we clobber
    );
}

